﻿
Public Class Form1

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Text = AppTitleAndVersion("")
        K_hook_DisableKeyboard()
    End Sub

    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        K_hook_EnableKeyboard()
    End Sub

    Private oldtime As Int32 = 0
    Friend Sub ShowKey(ByVal scanCode As Int32, _
                        ByVal vkCode As Int32, _
                        ByVal flags As Int32, _
                        ByVal ExtraInfo As Int32, _
                        ByVal time As Int32)

        With DGV_KeyPressed
            If time - oldtime > 300 Then .Rows.Clear()
            '
            .Rows.Add()
            Dim n As Int32 = .Rows.Count - 1
            .Item(0, n).Value = Trim(Str(n + 1))
            .Item(1, n).Value = Hex(scanCode)
            .Item(2, n).Value = Hex(vkCode) + "  " + vkCodeToText(vkCode)
            .Item(3, n).Value = Hex(flags) + "  " + FlagToText(flags)
            '.Item(4, n).Value = Hex(lParam.dwExtraInfo)
            '.Item(5, n).Value = lParam.time
        End With

        oldtime = time
    End Sub


    Private Function vkCodeToText(ByVal vk As Int32) As String
        Select Case vk

            Case 1 : vkCodeToText = "Left btn"       ' VK_LBUTTON
            Case 2 : vkCodeToText = "Right btn"      ' VK_RBUTTON
            Case 3 : vkCodeToText = "CTRL-break"     ' VK_CANCEL
            Case 4 : vkCodeToText = "Middle btn"     ' VK_MBUTTON

            Case 8 : vkCodeToText = "BackSpace"
            Case 9 : vkCodeToText = "Tab"
            Case 10 : vkCodeToText = "LineFeed"
            Case 12 : vkCodeToText = "Clear"
            Case 13 : vkCodeToText = "Enter"

            Case 16 : vkCodeToText = "SHIFT"         ' VK_SHIFT
            Case 17 : vkCodeToText = "CTRL"          ' VK_CONTROL
            Case 18 : vkCodeToText = "ALT"           ' VK_MENU
            Case 19 : vkCodeToText = "PAUSE"         ' VK_PAUSE
            Case 20 : vkCodeToText = "CapsLock"      ' VK_CAPITAL
            Case 27 : vkCodeToText = "Escape"

            Case 32 : vkCodeToText = "SPACE"         ' VK_SPACE

            Case 33 : vkCodeToText = "PAGE UP"       ' VK_PRIOR
            Case 34 : vkCodeToText = "PAGE DOWN"     ' VK_NEXT
            Case 35 : vkCodeToText = "END"           ' VK_END
            Case 36 : vkCodeToText = "HOME"          ' VK_HOME
            Case 37 : vkCodeToText = "LEFT"          ' VK_LEFT
            Case 38 : vkCodeToText = "UP"            ' VK_UP
            Case 39 : vkCodeToText = "RIGHT"         ' VK_RIGHT
            Case 40 : vkCodeToText = "DOWN"          ' VK_DOWN
            Case 41 : vkCodeToText = "SELECT"        ' VK_SELECT

            Case 43 : vkCodeToText = "EXECUTE"       ' VK_EXECUTE
            Case 44 : vkCodeToText = "PRINT SCREEN"  ' VK_SNAPSHOT
            Case 45 : vkCodeToText = "INSERT"        ' VK_INSERT
            Case 46 : vkCodeToText = "DELETE"        ' VK_DELETE

            Case 47 : vkCodeToText = "HELP"          ' VK_HELP

            Case 48 To 57 : vkCodeToText = Chr(vk)   ' numbers "0" to "9"

            Case 65 To 90 : vkCodeToText = Chr(vk)   ' letters "A" to "Z"

            Case 91 : vkCodeToText = "Left Windows"  ' VK_LWIN
            Case 92 : vkCodeToText = "Right Windows" ' VK_LWIN
            Case 93 : vkCodeToText = "Menu Apps"     ' VK_APPS

            Case 96 To 105 : vkCodeToText = "Keypad " & Trim(Str(vk - 95)) ' Numeric keypad VK_NUMPAD0 to 9

            Case 106 : vkCodeToText = "Multiply"     ' VK_MULTIPLY
            Case 107 : vkCodeToText = "Add"          ' VK_ADD
            Case 108 : vkCodeToText = "Separator"    ' VK_SEPARATOR
            Case 109 : vkCodeToText = "Subtract"     ' VK_SUBTRACT
            Case 110 : vkCodeToText = "Decimal"      ' VK_DECIMAL
            Case 111 : vkCodeToText = "Divide"       ' VK_DIVIDE

            Case 112 To 126 : vkCodeToText = "F" & Trim(Str(vk - 111)) ' function keys VK_F1 to VK_F24

            Case 127 : vkCodeToText = "DELETE"

            Case 128 To 135 : vkCodeToText = "F" & Trim(Str(vk - 111)) ' function keys VK_F1 to VK_F24

            Case 144 : vkCodeToText = "NUM LOCK"     ' VK_NUMLOCK
            Case 145 : vkCodeToText = "SCROLL LOCK"  ' VK_SCROLL

            Case 160, 161 : vkCodeToText = "SHIFT"
            Case 162, 163 : vkCodeToText = "CTRL"
            Case 164, 165 : vkCodeToText = "ALT"

            Case 246 : vkCodeToText = "Attn"         ' VK_ATTN
            Case 247 : vkCodeToText = "CrSel"        ' VK_CRSEL
            Case 248 : vkCodeToText = "ExSel"        ' VK_EXSEL
            Case 249 : vkCodeToText = "Erase EOF"    ' VK_EREOF
            Case 250 : vkCodeToText = "Play"         ' VK_PLAY
            Case 251 : vkCodeToText = "Zoom"         ' VK_ZOOM
            Case 252 : vkCodeToText = "NoName"       ' VK_NONAME
            Case 253 : vkCodeToText = "PA1"          ' VK_PA1
            Case 254 : vkCodeToText = "Clear"        ' VK_OEM_CLEAR

            Case Else : vkCodeToText = "hex:" & Hex(vk) & "  dec:" & Trim(Str(vk))
        End Select
        vkCodeToText = "( " + vkCodeToText + " )"
    End Function

    Private Function FlagToText(ByVal f As Int32) As String
        FlagToText = ""
        If (f And 1) <> 0 Then FlagToText += "EXT"
        If (f And 16) <> 0 Then FlagToText += "INJ"
        If (f And 32) <> 0 Then FlagToText += "ALT"
        If (f And 128) <> 0 Then FlagToText += "UP"
        If FlagToText <> "" Then FlagToText = "( " + FlagToText + " )"
    End Function

End Class